<!--
	$types = [
	'mimetype' => 'string',
	'mtime' => 'integer',
	'name' => 'string',
	'path' => 'string',
	'size' => 'integer',
	'tagname' => 'string',
	'favorite' => 'boolean',
	'fileid' => 'integer',
	'storage' => 'integer',

	'systemtags' => 'array',
	];
	$comparisons = [
	'mimetype' => ['eq', 'like'],
	'mtime' => ['eq', 'gt', 'lt', 'gte', 'lte'],
	'name' => ['eq', 'like', 'clike'],
	'path' => ['eq', 'like', 'clike'],
	'size' => ['eq', 'gt', 'lt', 'gte', 'lte'],
	'tagname' => ['eq', 'like'],
	'favorite' => ['eq'],
	'fileid' => ['eq'],
	'storage' => ['eq'],

	'systemtag' => ['eq'],
	];
-->
<template>
	<div>
		<form class="filters-form" @submit.prevent="getFilteredNodes" @reset.prevent="clearFilters">
			<div class="filter-name">
				<label for="filter-name"> {{ t('sorts', 'Filename') }} </label>
				<input
					id="filter-name"
					v-model="filterName.name"
					name="name"
					placeholder="Search in file names"
					type="text">
				<CheckboxRadioSwitch :checked.sync="filterName.caseSensitivity" type="switch">
					{{ t('sorts', 'Case sensitive') }}
				</CheckboxRadioSwitch>
			</div>
			<div class="filters-mtime-size">
				<div class="filter-mtime">
					<span> {{ t('sorts', 'Last modification: ') }} </span>
					<label> {{ t('sorts', 'starting from') }} </label>
					<DatetimePicker
						v-model="filterMtime.min"
						name="min-mtime"
						:clearable="true"
						placeholder="Modified since ..."
						value-type="X"
						type="date" />
					<label> {{ t('sorts', 'to') }} </label>
					<DatetimePicker
						v-model="filterMtime.max"
						name="max-mtime"
						:clearable="true"
						placeholder="Modified until ..."
						value-type="X"
						type="date" />
				</div>
				<div class="filter-size">
					<span> {{ t('sorts', 'Size: ') }} </span>
					<label for="filter-min-size"> {{ t('sorts', 'starting from') }} </label>
					<input
						id="filter-min-size"
						v-model="filterSize.min"
						name="min-size"
						placeholder="Min."
						type="number">
					<Multiselect
						v-model="filterSize.minUnit"
						:options="sizeUnits" />
					<label for="filter-max-size"> {{ t('sorts', 'to') }} </label>
					<input
						id="filter-max-size"
						v-model="filterSize.max"
						name="max-size"
						placeholder="Max."
						type="number">
					<Multiselect
						v-model="filterSize.maxUnit"
						:options="sizeUnits" />
				</div>
			</div>
			<div class="filters-favorite-systemtags">
				<div
					class="filter-favorite">
					<CheckboxRadioSwitch :checked.sync="filterFavorite" type="switch">
						{{ t('sorts', 'Restrict to favorites') }}
					</CheckboxRadioSwitch>
				</div>
				<div class="filter-systemtags">
					<label> {{ t('sorts', 'Any of those Tags: ') }} </label>
					<MultiselectTags
						v-model="filterSystemtags"
						name="systemtags" />
				</div>
			</div>
			<button type="submit">
				{{ t('sorts', 'Search') }}
			</button>
			<button type="reset">
				{{ t('sorts', 'Clear') }}
			</button>
		</form>
		<div v-if="isFilter">
			<NodesList
				v-if="!isNodesTreeNull()"
				:nodes-tree="nodesTree"
				:is-filter="true"
				@toggle-directory="toggleDirectory($event)"
				@enter-directory="enterDirectory($event)" />
			<EmptyContent v-else icon="icon-file">
				Nothing found
				<template #desc>
					Try changing the filters
				</template>
			</EmptyContent>
		</div>
	</div>
</template>
<script>
import axios from '@nextcloud/axios'
import { generateUrl } from '@nextcloud/router'

import DatetimePicker from '@nextcloud/vue/dist/Components/DatetimePicker'
import Multiselect from '@nextcloud/vue/dist/Components/Multiselect'
import MultiselectTags from '@nextcloud/vue/dist/Components/MultiselectTags'
import CheckboxRadioSwitch from '@nextcloud/vue/dist/Components/CheckboxRadioSwitch'
import EmptyContent from '@nextcloud/vue/dist/Components/EmptyContent'

import NodesList from './NodesList'

export default {
	name: 'Filters',
	components: {
		NodesList,
		DatetimePicker,
		Multiselect,
		MultiselectTags,
		CheckboxRadioSwitch,
		EmptyContent,
	},
	props: {
		isFilter: {
			type: Boolean,
		},
	},
	data() {
		return {
			sizeUnits: ['B', 'KB', 'MB', 'GB'],
			yesNoOptions: [t('sorts', 'clear'), t('sorts', 'yes'), t('sorts', 'no')],
			filterName: {
				name: '',
				caseSensitivity: false,
			},
			filterMtime: {
				min: '',
				max: '',
			},
			filterSize: {
				min: '',
				minUnit: 'KB',
				max: '',
				maxUnit: 'KB',
			},
			filterFavorite: false,
			filterSystemtags: [],
			nodesTree: [],
		}
	},
	computed: {
		sortAttribute() {
			const res = this.$route.query.sortAttribute
			return typeof res === 'undefined' ? 'name' : res
		},
		sortDescending() {
			const res = this.$route.query.sortDescending
			return typeof res === 'undefined' ? false : res
		},
	},
	methods: {
		clearFilters() {
			if (this.isFilter) {
				this.$emit('toggle-filters')
			}
			this.filterName.name = ''
			this.filterMtime.min = ''
			this.filterMtime.max = ''
			this.filterSize.min = ''
			this.filterSize.minUnit = 'KB'
			this.filterSize.max = ''
			this.filterSize.maxUnit = 'KB'
			this.filterFavorite = false
			this.filterSystemtags = []
		},

		isNodesTreeNull() {
			return !(Array.isArray(this.nodesTree) && this.nodesTree.length)
		},

		async getFilteredNodes() {
			const providedFilters = this.filters()
			if (!providedFilters.length) {
				// if no filter are provided, reset the vue to file explorer
				this.clearFilters()
			} else {
				if (!this.isFilter) {
					this.$emit('toggle-filters')
				}
				const response = await axios.post(generateUrl('/apps/sorts/search'), {
					filters: providedFilters,
					sortField: this.sortAttribute,
					direction: this.sortDescending === true ? 'desc' : 'asc',
				})
				this.nodesTree = response.data
			}
		},

		filters() {
			const res = []

			const getFileSize = function(value, suffix) {
				switch (suffix) {
				case 'KB':
					return value * 1000
				case 'MB':
					return value * 1000000
				case 'GB':
					return value * 1000000000
				default:
					return value
				}
			}

			if (this.filterName.name) {
				const comparison = this.filterName.caseSensitivity ? 'clike' : 'like'
				res.push([comparison, 'name', this.filterName.name])
			}
			if (parseInt(this.filterMtime.min)) {
				res.push(['gte', 'mtime', parseInt(this.filterMtime.min)])
			}
			if (parseInt(this.filterMtime.max)) {
				res.push(['lte', 'mtime', parseInt(this.filterMtime.max)])
			}
			if (parseInt(this.filterSize.min)) {
				res.push(['gte', 'size', getFileSize(parseInt(this.filterSize.min), this.filterSize.minUnit)])
			}
			if (parseInt(this.filterSize.max)) {
				res.push(['lte', 'size', getFileSize(parseInt(this.filterSize.max), this.filterSize.maxUnit)])
			}
			if (this.filterFavorite) {
				res.push(['eq', 'favorite', this.filterFavorite])
			}
			if (Array.isArray(this.filterSystemtags) && this.filterSystemtags.length) {
				res.push(['eq', 'systemtags', this.filterSystemtags])
			}
			return res
		},

		enterDirectory(newPath) {
			this.$router.push({
				name: 'Main',
				query: { ...this.$route.query, path: newPath },
			})
			this.$emit('toggle-filters')
		},

		// TODO: function copy pasted from FileExplorer. Make a util.js with those instead
		async toggleDirectory(path) {
			const node = this.getNodeByPath(path)
			if (node.type === 'dir') {
				if (Array.isArray(node.nodes) && node.nodes.length) {
					this.$delete(node, 'nodes')
				} else {
					const response = await this.getNodes(node.path)
					this.$set(node, 'nodes', response.data)
				}
			}
		},
		async getNodes(path) {
			if (path === '/') {
				return await axios.get(generateUrl('/apps/sorts/nodelist'), { params: { sortAttribute: this.sortAttribute, sortDescending: this.sortDescending } })
			} else {
				return await axios.get(generateUrl(`/apps/sorts/nodelist/${path}`), { params: { sortAttribute: this.sortAttribute, sortDescending: this.sortDescending } })
			}
		},
		getNodeByPath(path) {
			const func = function(nodes) {
				for (let i = 0; i < nodes.length; i++) {
					if (nodes[i].path === path) {
						return nodes[i]
					} else if (Array.isArray(nodes[i].nodes)) {
						const res = func(nodes[i].nodes)
						if (res !== null) {
							return res
						}
					}
				}
				return null
			}
			if (!this.isNodesTreeNull()) {
				return func(this.nodesTree)
			}
			return null
		},
	},
}

</script>

<style>
.filters-form label {
	font-weight: 600;
}

.filter-name, .filter-favorite {
	display: flex;
	align-items: center;
	column-gap: 1rem;
	flex-wrap: wrap;
}

.filter-name {
	font-size: 1rem;
}

.filter-name label {
	flex: 0;
}

.filter-name input#filter-name {
	height: 3.5rem;
	font-size: 1.5rem;
	flex: 7;
	min-width: 17rem;
}

.filter-name .checkbox-radio-switch {
	flex: 1;
	display: block;
}

.filters-mtime-size, .filters-favorite-systemtags {
	display: flex;
	flex-wrap: wrap;
	column-gap: 1rem;
	align-items: center;
}

.filters-form {
	margin-bottom: 1rem;
	border-bottom: 1px solid #eee;
	padding-bottom: 0.5rem;
	padding-top: 1rem;
}
</style>
